#ifndef COLLECTION_H_
#define COLLECTION_H_

#include <vector>
#include <ne_props.h>
#include "session.h"
#include "webdav.h"

namespace webdav
{

class Collection
{
public:
	Collection(Session&);
	virtual ~Collection();

	bool GetList(const char* path, const char* uri, Resource** buf, size_t* buf_size);

private:
	Session& sess_;

private:
	int FetchResourceList(const char* uri, Resource **reslist);
	static int StartElement(void *userdata, int parent, 
						    const char *nspace, const char *name, const char **atts);

	static void Results(void *userdata, const ne_uri *uri,
						const ne_prop_result_set *set);
	static void* CreatePrivate(void *userdata, const ne_uri *uri);
};

}

#endif // COLLECTION_H_
