#include "http_put.h"

#include <stdio.h>
#include <io.h>
#include <wchar.h>
#include <tchar.h>
#include <sys/stat.h> /* for struct stat */

#include <ne_socket.h>
#include <ne_basic.h>
#include <ne_locks.h>

namespace webdav
{

HttpPut::HttpPut()
{
}

HttpPut::~HttpPut()
{
}

ssize_t HttpPut::ReadFile(void *userdata, char *buffer, unsigned int count)
{
	HttpPut* http = reinterpret_cast<HttpPut*>(userdata);

	if(count != 0){
		if (http->file_remain_ == 0){
			return 0;
		}

		if ((__int64)count > http->file_remain_){
			count = http->file_remain_;
		}

		size_t size =  _read(http->file_fd_, buffer, count);

		if(http->request_handler_(http->request_handler_data_, buffer, count) < 0){
			return -1;
		}

		return size;
	}else{
		__int64 newoff;

		newoff = _lseeki64(http->file_fd_, http->file_offset_, SEEK_SET);

		if (newoff == http->file_offset_) {
			http->file_remain_ = http->file_length_;
			return 0;
		} else {
			if (newoff == -1) {
				// TODO: error handling
			} else {
				// TODO: error handling
			}

			return -1;
		}
	}
}

bool HttpPut::Put(ne_session* sess, const char* rpath, const char* lpath)
{
	file_fd_ = 0;
	file_offset_ = 0;
	file_length_ = 0;
	file_remain_ = 0;

	FILE* fp = _tfopen(lpath, _T("rb"));
	if(fp == NULL){
		// TODO: error handling
		return false;
	}

	const char *uri = rpath;
	file_fd_ = _fileno(fp);

	struct __stat64 st;
    if(_fstat64(file_fd_, &st) != 0) {
        return false;
    }
   
    file_length_ = st.st_size;

    ne_request* req = ne_request_create(sess, "PUT", uri);

    ne_lock_using_resource(req, uri, 0);
    ne_lock_using_parent(req, uri);

	ne_add_response_body_reader(req, AcceptResponse, response_handler_, response_handler_data_);
	ne_set_request_body_provider(req, st.st_size, ReadFile, this);

	bool ret = true;
	
    int res = ne_request_dispatch(req);
	if(res == NE_OK && ne_get_status(req)->klass != 2){
		ret = false;
	}

    ne_request_destroy(req);

	fclose(fp);

	return ret;
}

}